//
//  Zhang̃Lu[V
//

#include "minpack.h"
#include "mat.h"
#include "gen_geometric_mat.h"

// LAPACKg
extern "C"{
#include "f2c.h"
#include "clapack.h"
}

// _Q\
struct point_t
{
	double x, y;
};

// Ή_̍\
struct data_t
{
	point_t wpts[100];
	point_t cpts[100];
	int     pts_num;
	double  H[9];
	double  ref[9];
	double  Rt[9];
};


// minpack̂߂globalϐ
point_t fcn_wpts[1000];
point_t fcn_cpts[1000];
double tmp_Rt[1000];
int fcn_pts_num;
int fcn_pts_list[1000];
int fcn_list_num;

// EWnJWn֕ϊ
void w2c_pt(point_t & in, point_t & out, double *H, double k1, double k2, double u0, double v0)
{
	double ix, iy, rx,ry, rz;
	rz = (in.x * H[3 * 2 + 0] + in.y * H[3 * 2 + 1] + H[3 * 2 + 2]);
	rx = (in.x * H[3 * 0 + 0] + in.y * H[3 * 0 + 1] + H[3 * 0 + 2]) / (rz);
	ry = (in.x * H[3 * 1 + 0] + in.y * H[3 * 1 + 1] + H[3 * 1 + 2]) / (rz);
	ix = (rx - u0) / 512.0;
	iy = (ry - v0) / 512.0;
	out.x = rx + (rx - u0) * (k1 * (ix*ix+iy*iy) + k2 * (ix*ix+iy*iy) * (ix*ix+iy*iy));
	out.y = ry + (ry - v0) * (k1 * (ix*ix+iy*iy) + k2 * (ix*ix+iy*iy) * (ix*ix+iy*iy));
};

// e덷Zo
double calc_projection_err(doublereal * vvec)
{
	int i, j, n;
	double dx, dy;
	double x, y, z, mx, my, tx, ty, ix, iy;
	double H[10][9], Rt[9];
	double A[9];
	double u0, v0, k1, k2;

	gen_intrinsic_mat(vvec[0], vvec[1], vvec[2], vvec[3], vvec[4], A);
	u0 = vvec[3];
	v0 = vvec[4];
	k1 = vvec[5];
	k2 = vvec[6];

	double err = 0.0;

	for(i = 0;i < fcn_list_num;i++)
	{
		for(j = 0;j < 9;j++)
		{
			Rt[j] = vvec[7 + i * 9 + j];
		};
		mat_mul(A, Rt, H[i], 3);
	};// i

	for(i = 0;i < fcn_pts_num;i++)
	{
		n = fcn_pts_list[i];
		x = H[n][0] * fcn_wpts[i].x + H[n][1] * fcn_wpts[i].y + H[n][2];
		y = H[n][3] * fcn_wpts[i].x + H[n][4] * fcn_wpts[i].y + H[n][5];
		z = H[n][6] * fcn_wpts[i].x + H[n][7] * fcn_wpts[i].y + H[n][8];
		mx = x / z;
		my = y / z;
		ix = (mx - u0) / 512.0;
		iy = (my - v0) / 512.0;

		tx = mx + (mx - u0) * (k1 * (ix*ix+iy*iy) + k2 * (ix*ix+iy*iy) * (ix*ix+iy*iy));
		ty = my + (my - v0) * (k1 * (ix*ix+iy*iy) + k2 * (ix*ix+iy*iy) * (ix*ix+iy*iy));

		err += sqrt((tx - fcn_cpts[i].x)*(tx - fcn_cpts[i].x) +  (ty - fcn_cpts[i].y)*(ty - fcn_cpts[i].y));
	};// i

	return err / (double)fcn_pts_num;
};


//*************************************************************************
// minpackpœK[`
//
void fcn_homography(integer * fnum, integer * vnum,
         doublereal * vvec, doublereal * fvec, integer * iflag)
{
	int i;
	double dx, dy;
	double x, y, z, mx, my;
	for(i = 0;i < fcn_pts_num;i++)
	{
		x = vvec[0] * fcn_wpts[i].x + vvec[1] * fcn_wpts[i].y + vvec[2];
		y = vvec[3] * fcn_wpts[i].x + vvec[4] * fcn_wpts[i].y + vvec[5];
		z = vvec[6] * fcn_wpts[i].x + vvec[7] * fcn_wpts[i].y + vvec[8];
		mx = x / z;
		my = y / z;
		fvec[i]               = mx - fcn_cpts[i].x;
		fvec[i + fcn_pts_num] = my - fcn_cpts[i].y;
	};// i
};

void fcn_homography_distortion(integer * fnum, integer * vnum,
         doublereal * vvec, doublereal * fvec, integer * iflag)
{
	int i, j, n;
	double dx, dy;
	double x, y, z, mx, my, tx, ty, ix, iy;
	double H[10][9], Rt[9];
	double A[9];
	double u0, v0, k1, k2;

	gen_intrinsic_mat(vvec[0], vvec[1], vvec[2], vvec[3], vvec[4], A);
	u0 = vvec[3];
	v0 = vvec[4];
	k1 = vvec[5];
	k2 = vvec[6];

	for(i = 0;i < fcn_list_num;i++)
	{
		for(j = 0;j < 9;j++)
		{
			Rt[j] = vvec[7 + i * 9 + j];
		};
		mat_mul(A, Rt, H[i], 3);
	};// i

	for(i = 0;i < fcn_pts_num;i++)
	{
		n = fcn_pts_list[i];
		x = H[n][0] * fcn_wpts[i].x + H[n][1] * fcn_wpts[i].y + H[n][2];
		y = H[n][3] * fcn_wpts[i].x + H[n][4] * fcn_wpts[i].y + H[n][5];
		z = H[n][6] * fcn_wpts[i].x + H[n][7] * fcn_wpts[i].y + H[n][8];
		mx = x / z;
		my = y / z;
		ix = (mx - u0) / 512.0;
		iy = (my - v0) / 512.0;

		tx = mx + (mx - u0) * (k1 * (ix*ix+iy*iy) + k2 * (ix*ix+iy*iy) * (ix*ix+iy*iy));
		ty = my + (my - v0) * (k1 * (ix*ix+iy*iy) + k2 * (ix*ix+iy*iy) * (ix*ix+iy*iy));

		fvec[i]               = tx - fcn_cpts[i].x;
		fvec[i + fcn_pts_num] = ty - fcn_cpts[i].y;
	};// i
};
// minpackpœK[`
//*************************************************************************



//********************************************************************************
//    Ή_p^ƃYc݃p^`œKŒBdata͏B
//********************************************************************************
void optimize_homography_distortion(
	double & alpha, double & beta, double & gamma, 
	double & u0, double & v0, double & k1, double & k2, 
	data_t * data, int N
	)
{
	int i, j;
	integer m, n;
	doublereal vvec[1000] = {0}, fvec[1000] = {0}, *wa, tol;
	integer info = 0, lwa = 0;
	integer *iwa;

	n = 0;				// œKׂxNg̎
	m = 0;		        // ړI֐̍
	for(i = 0;i < N;i++)
	{
		m += 2 * data[i].pts_num;
	};


	vvec[n++] = alpha;
	vvec[n++] = beta;
	vvec[n++] = gamma;
	vvec[n++] = u0;
	vvec[n++] = v0;
	vvec[n++] = k1;
	vvec[n++] = k2;

	for(i = 0;i < N;i++)
	{
		for(j = 0;j < 9;j++)
		{
			vvec[n++] = data[i].Rt[j];
		};// j
	};// i

	fcn_pts_num  = 0;
	fcn_list_num = N;
	for(i = 0;i < N;i++)
	{
		for(j = 0;j < data[i].pts_num;j++)
		{
			fcn_wpts[fcn_pts_num] = data[i].wpts[j];
			fcn_cpts[fcn_pts_num] = data[i].cpts[j];
			fcn_pts_list[fcn_pts_num] = i;
			fcn_pts_num++;
		}; // j
	};// i


	lwa = m*n+5*n+m;
	wa  = new doublereal[lwa];
	iwa = new integer[lwa];
	tol = 10e-10;

	double e1, e2;

	e1 = calc_projection_err(vvec);
	printf("optimizing....");
	lmdif1_((U_fp)(fcn_homography_distortion), &m, &n, vvec, fvec, &tol, &info, iwa, wa, &lwa);
	printf("ok\n");
	e2 = calc_projection_err(vvec);

	alpha = vvec[0];
	beta  = vvec[1];
	gamma = vvec[2];
	u0 = vvec[3];
	v0 = vvec[4];
	k1 = vvec[5];
	k2 = vvec[6];
	// print log
	printf("[***RESULT***]\nerr=%f[pix](initial) ---> %f[pix](after non-linear optimize)\n", e1, e2);
	printf("[***ESTIMATED PARAMETER***]\nalpha=%f, beta=%f, gamma=%f\n", alpha, beta, gamma);
	printf("u0=%f, v0=%f\n", u0, v0);
	printf("k1=%f, k2=%f\n", k1, k2);

	delete wa;
	delete iwa;

}

//********************************************************************************
//    Ή_zOtB`œKŒBh͏B
//********************************************************************************
void optimize_homography(double *h, point_t *wpts, point_t *cpts, int N)
{
	int i;
	integer m, n;
	doublereal vvec[1000] = {0}, fvec[1000] = {0}, wa[1000] = {0}, tol;
	integer info = 0, lwa = 0;
	integer iwa[1000] = {0};

	n = 9;	    // œKׂxNg̎
	m = 2 * N;	// ړI֐̍

	lwa = m*n+5*n+m;
	tol = 10e-10;

	for(i = 0;i < 9;i++)
	{
		vvec[i] = h[i];
	};

	fcn_pts_num = N;
	for(i = 0;i < N;i++)
	{
		fcn_wpts[i] = wpts[i];
		fcn_cpts[i] = cpts[i];
	};
	lmdif1_((U_fp)(fcn_homography), &m, &n, vvec, fvec, &tol, &info, iwa, wa, &lwa);
	for(i = 0;i < 9;i++)
	{
		h[i] = vvec[i];
	};

};


//********************************************************************************
// QƓ_wptsƊϑ_cptszOtBseH𐄒
//********************************************************************************
void estimate_homography(
	point_t * wpts, point_t * cpts, 
	int pts_num, 
	double *eH
	)
{
	double B[10000];
	double BB[81];
	int i, j, k, n;

	// Zhang̘_̎:t^A
	for(i = 0;i < pts_num;i++)
	{
		n = 2 * i;
		B[n * 9 + 0] = wpts[i].x;             B[n * 9 + 1] = wpts[i].y;             B[n * 9 + 2] = 1.0;
		B[n * 9 + 3] = 0.0;                   B[n * 9 + 4] = 0.0;                   B[n * 9 + 5] = 0.0;
		B[n * 9 + 6] = -cpts[i].x * wpts[i].x;B[n * 9 + 7] = -cpts[i].x * wpts[i].y;B[n * 9 + 8] = -cpts[i].x;
		n = 2 * i + 1;
		B[n * 9 + 0] = 0.0;                   B[n * 9 + 1] = 0.0;                   B[n * 9 + 2] = 0.0;
		B[n * 9 + 3] = wpts[i].x;             B[n * 9 + 4] = wpts[i].y;             B[n * 9 + 5] = 1.0;
		B[n * 9 + 6] = -cpts[i].y * wpts[i].x;B[n * 9 + 7] = -cpts[i].y * wpts[i].y;B[n * 9 + 8] = -cpts[i].y;
	};// i

	// B^T B
	for(i = 0;i < 9;i++)
	{
		for(j = 0;j < 9;j++)
		{
			double sum = 0.0;
			for(k = 0;k < 2 * pts_num;k++)
			{
				sum += B[k * 9 + i] * B[k * 9 + j];
			};// k
			BB[i * 9 + j] = sum;
		};//j
	};// i


	long N = 9;
	double wr[1000], wi[2], work[1000], vl[1000], vr[1000];
	long lda=N,ldvl=N,ldvr=N, lwork = 3 * N, info, ldvt = 5;

	// `@FŗL
	dsyev_("V", "U", &N, BB, &lda, wr, work, &lwork, &info);
	double h[9];
	for(i = 0;i < 9;i++)
	{
		h[i] = BB[i];
	};
	// `@F}J[g@Œ
	optimize_homography(h, wpts, cpts, pts_num);

	// ʂi[
	eH[3 * 0 + 0] = h[0];eH[3 * 0 + 1] = h[1];eH[3 * 0 + 2] = h[2];
	eH[3 * 1 + 0] = h[3];eH[3 * 1 + 1] = h[4];eH[3 * 1 + 2] = h[5];
	eH[3 * 2 + 0] = h[6];eH[3 * 2 + 1] = h[7];eH[3 * 2 + 2] = h[8];

};




//********************************************************************************
// ̉摜̊ϑ_̑ΉAp^𐄒
//********************************************************************************
void estimate_intrinsic(
	data_t * data,		// Ή_f[^
	int N,				// 摜
	double & alpha, double & beta, double & gamma, 
	double & u0, double & v0, double & k1, double & k2
	)
{
	int n, i, j, k;
	double V[1000], VV[1000], v[2][2][6];

	// sV쐬:Zhang_̎(9)
	for(n = 0;n < N;n++)
	{
		for(i = 0;i < 2;i++)
		{
			for(j = 0;j < 2;j++)
			{
				v[i][j][0] = data[n].H[i + 3 * 0] * data[n].H[j + 3 * 0];
				v[i][j][1] = data[n].H[i + 3 * 0] * data[n].H[j + 3 * 1] + data[n].H[i + 3 * 1] * data[n].H[j + 3 * 0];
				v[i][j][2] = data[n].H[i + 3 * 1] * data[n].H[j + 3 * 1];
				v[i][j][3] = data[n].H[i + 3 * 2] * data[n].H[j + 3 * 0] + data[n].H[i + 3 * 0] * data[n].H[j + 3 * 2];
				v[i][j][4] = data[n].H[i + 3 * 2] * data[n].H[j + 3 * 1] + data[n].H[i + 3 * 1] * data[n].H[j + 3 * 2];
				v[i][j][5] = data[n].H[i + 3 * 2] * data[n].H[j + 3 * 2];
			};//j
		};//i
		for(j = 0;j < 6;j++)
		{
			V[(2 * n)     * 6 + j] = v[0][1][j]; 
			V[(2 * n + 1) * 6 + j] = v[0][0][j] - v[1][1][j]; 
		};
	};// n

	// V^T V
	for(i = 0;i < 6;i++)
	{
		for(j = 0;j < 6;j++)
		{
			double sum = 0.0;
			for(k = 0;k < 2 * N;k++)
			{
				sum += V[k * 6 + i] * V[k * 6 + j];
			};// k
			VV[i * 6 + j] = sum;
		};//j
	};// i


	long P = 6;
	double wr[1000], wi[2], work[1000], vl[1000], vr[1000];
	long lda=P,ldvl=P,ldvr=P, lwork = 3 * P, info, ldvt = 5;

	// ŗL
	dsyev_("V", "U", &P, VV, &lda, wr, work, &lwork, &info);

	// ߂ŗLxNgsa\FZhang_̎(6)
	double B[9];

	B[3 * 0 + 0] = VV[0];
	B[3 * 0 + 1] = B[3 * 1 + 0] = VV[1];
	B[3 * 1 + 1] = VV[2];
	B[3 * 0 + 2] = B[3 * 2 + 0] = VV[3];
	B[3 * 1 + 2] = B[3 * 2 + 1] = VV[4];
	B[3 * 2 + 2] = VV[5];

	// p[^FZhang̘_̕t^B
	double lambda;
	v0     = (B[3 * 0 + 1] * B[3 * 0 + 2] - B[3 * 0 + 0] * B[3 * 1 + 2]) / (B[3 * 0 + 0] * B[3 * 1 + 1] - B[3 * 0 + 1] * B[3 * 0 + 1]);
	lambda = B[3*2+2] - (B[3*0+2]*B[3*0+2] + v0 * (B[3*0+1]*B[3*0+2]-B[3*0+0]*B[3*1+2]) ) / B[3*0+0];
	alpha  = sqrt(lambda / B[3*0+0]);
	beta   = sqrt(lambda * B[3*0+0] / (B[3*0+0]*B[3*1+1] - B[3*0+1]*B[3*0+1]));
	gamma  = -B[3*0+1] * alpha * alpha * beta / lambda;
	u0     = gamma * v0 / beta - B[3*0+2] * alpha * alpha / lambda;
	// s̋t
	double invA[9];
	invA[0] = 1.0 / alpha;
	invA[1] = -gamma / (alpha * beta);
	invA[2] = (gamma * v0 - u0 * beta) / (alpha * beta);
	invA[3] = 0.0;invA[4] = 1.0 / beta;invA[5] = -v0 / beta;
	invA[6] = 0.0;invA[7] = 0.0;       invA[8] = 1.0;
	// invAƃzOtBe摜łRts߂
	for(i = 0;i < N;i++)
	{
		gen_Rt_from_AH(invA, data[i].H, data[i].Rt);
	};
	k1 = k2 = 0.0;
	// `@F}J[g@Œ
	optimize_homography_distortion(alpha, beta, gamma, u0, v0, k1, k2, data, N);

};
