//
//  􉽊wϊp̍s񐶐
//

#ifndef _GEN_GEOMETRIC_MAT_
#define _GEN_GEOMETRIC_MAT_


#include "mat.h"

// s A 
void gen_intrinsic_mat(double alpha, double beta, double gamma, double u0, double v0, double *A)
{
	A[0 * 3 + 0] = alpha;A[0 * 3 + 1] = gamma;A[0 * 3 + 2] =  u0;
	A[1 * 3 + 0] =   0.0;A[1 * 3 + 1] =  beta;A[1 * 3 + 2] =  v0;
	A[2 * 3 + 0] =   0.0;A[2 * 3 + 1] =   0.0;A[2 * 3 + 2] = 1.0;
};

// ]s R iR̃IC[p琶j
void gen_rot_mat(double x, double y, double z, double *R)
{
	double Rx[9], Ry[9], Rz[9], tmp[9];

	Rz[0 * 3 + 0] = cos(z);Rz[0 * 3 + 1] = -sin(z);Rz[0 * 3 + 2] = 0.0;
	Rz[1 * 3 + 0] = sin(z);Rz[1 * 3 + 1] =  cos(z);Rz[1 * 3 + 2] = 0.0;
	Rz[2 * 3 + 0] = 0.0;   Rz[2 * 3 + 1] =     0.0;Rz[2 * 3 + 2] = 1.0;

	Ry[0 * 3 + 0] =  cos(y);Ry[0 * 3 + 1] =     0.0;Ry[0 * 3 + 2] = sin(y);
	Ry[1 * 3 + 0] =     0.0;Ry[1 * 3 + 1] =     1.0;Ry[1 * 3 + 2] = 0.0;
	Ry[2 * 3 + 0] = -sin(y);Ry[2 * 3 + 1] =     0.0;Ry[2 * 3 + 2] = cos(y);

	Rx[0 * 3 + 0] =     1.0;Rx[0 * 3 + 1] =     0.0;Rx[0 * 3 + 2] =     0.0;
	Rx[1 * 3 + 0] =     0.0;Rx[1 * 3 + 1] =  cos(x);Rx[1 * 3 + 2] = -sin(x);
	Rx[2 * 3 + 0] =     0.0;Rx[2 * 3 + 1] =  sin(x);Rx[2 * 3 + 2] =  cos(x);

	mat_mul(Ry, Rx, tmp, 3);
	mat_mul(Rz, tmp,  R, 3);
};

// zOtBiΉeϊj{sړ@s H iQcpj
void gen_homography_2D(double x, double y, double z, double tx, double ty, double tz, 
	                   double alpha, double beta, double gamma, double u0, double v0, double *H
					   )
{
	double R[9], A[9], T[9];
	gen_rot_mat(x, y, z, R);
	gen_intrinsic_mat(alpha, beta, gamma, u0, v0, A);
	T[3 * 0 + 0] = R[3 * 0 + 0];T[3 * 0 + 1] = R[3 * 0 + 1];T[3 * 0 + 2] = tx;
	T[3 * 1 + 0] = R[3 * 1 + 0];T[3 * 1 + 1] = R[3 * 1 + 1];T[3 * 1 + 2] = ty;
	T[3 * 2 + 0] = R[3 * 2 + 0];T[3 * 2 + 1] = R[3 * 2 + 1];T[3 * 2 + 2] = tz;
	mat_mul(A, T, H, 3);
};

// A^-1H]s𐶐
void gen_Rt_from_AH(double *invA, double *H, double * Rt)
{
	double lambda;
	double r1[3], r2[3], r3[3], t[3];
	double h1[3], h2[3], h3[3];
	double R[9];
	int i;

	h1[0] = H[0];
	h1[1] = H[3];
	h1[2] = H[6];
	h2[0] = H[1];
	h2[1] = H[4];
	h2[2] = H[7];
	h3[0] = H[2];
	h3[1] = H[5];
	h3[2] = H[8];

	mat_vec(invA, h1, r1, 3);
	mat_vec(invA, h2, r2, 3);
	mat_vec(invA, h3,  t, 3);

	lambda = 1.0 / sqrt(dot(r1, r1, 3));

	for(i = 0;i < 3;i++)
	{
		r1[i] *= lambda;
		r2[i] *= lambda;
		t[i]  *= lambda;
	};
	cross3(r1, r2, r3);
	for(i = 0;i < 3;i++)
	{
		R[3 * i + 0] = r1[i];
		R[3 * i + 1] = r2[i];
		R[3 * i + 2] = r3[i];
	};	
	for(i = 0;i < 3;i++)
	{
		Rt[3 * i + 0] = r1[i];
		Rt[3 * i + 1] = r2[i];
		Rt[3 * i + 2] =  t[i];
	};

};

#endif

