
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "bmp_loader.h"
#include "calib.h"


#define M_PI 3.141592653589793


//
// V~[Vf[^𐶐(QƁEϑ_Ƌ^摜)
//
void gen_pts(
	char *file, 
	double ax, double ay, double az, double tx, double ty, double tz, 
	double alpha, double beta, double gamma, double u0, double v0, 
	double k1, double k2,
	int w, int h,
	data_t & data)
{
	int x, y;
	point_t wpt, cpt;
	unsigned char *img;
	img   = new unsigned char[3 * w * h];

	memset(img, 0, 3 * w * h);

	gen_homography_2D(
		ax, ay, az,
		tx, ty, tz,
		alpha, beta, gamma,
		u0, v0, data.ref);

	data.pts_num = 0;
	//
	for(x = -2*w;x <= 2*w; x+= 50)
	{
		for(y = -2*h;y <= 2*h;y+=1)
		{
			wpt.x = x;
			wpt.y = y;
			w2c_pt(wpt, cpt, data.ref, k1, k2, u0, v0);

			if(cpt.x > 0 && cpt.y > 0 && cpt.x < w && cpt.y < h)
			{
				int dx, dy;
				dx = cpt.x;
				dy = cpt.y;
				img[3 * (dx * w + dy) + 1] = 128;
			};
		};//y
	};//x
	for(x = -2*w;x <= 2*w; x+= 1)
	{
		for(y = -2*h;y <= 2*h;y+=50)
		{
			wpt.x = x;
			wpt.y = y;
			w2c_pt(wpt, cpt, data.ref, k1, k2, u0, v0);

			if(cpt.x > 0 && cpt.y > 0 && cpt.x < w && cpt.y < h)
			{
				int dx, dy;
				dx = cpt.x;
				dy = cpt.y;
				img[3 * (dx * w + dy) + 1] = 128;
			};
		};//y
	};//x

	//
	for(x = -80;x <= 80; x+= 40)
	{
		for(y = -80;y <= 80;y+=40)
		{
			wpt.x = x;
			wpt.y = y;
			w2c_pt(wpt, cpt, data.ref, k1, k2, u0, v0);
			cpt.x += 0.0 * (rand()%100)/100.0;
			cpt.y += 0.0 * (rand()%100)/100.0;

			data.wpts[data.pts_num] = wpt;
			data.cpts[data.pts_num] = cpt;
			data.pts_num++;

			if(cpt.x > 0 && cpt.y > 0 && cpt.x < w && cpt.y < h)
			{
				int dx, dy;
				dx = cpt.x;
				dy = cpt.y;
				img[3 * (dx * w + dy) + 0] = 255;
				img[3 * (dx * w + dy) + 1] = 255;
				img[3 * (dx * w + dy) + 2] = 255;
			};
		};//y
	};//x

	// 摜
	write_bmp_rgb(file, img, w, h);

	delete img;
};

//
// V~[Vf[^̍쐬Bgēp^𐄒B
//
void test()
{
	int w, h;
	int i, j;
	double k1, k2, u0, v0;
	double alpha, beta, gamma;
	int    img_n;
	char file[256];
	data_t data[10];

	img_n = 6;		// 摜
	w = h = 512;	// 摜TCY
	u0 = 256.0;		// 摜̌S
	v0 = 256.0;
	k1 =    -0.3;	// Yc݃p^
	k2 =     0.1;	//

	// p^
	alpha = 512;	
	beta  = 512;
	gamma = 1.09083;


	printf("[***GEN SIMULATION DATA***]\nalpha=%f, beta=%f, gamma=%f\n", alpha, beta, gamma);
	printf("u0=%f, v0=%f\n", u0, v0);
	printf("k1=%f, k2=%f\n", k1, k2);

	// e摜𐶐
	for(i = 0;i < img_n;i++)
	{
		sprintf(file,"./img/test%d.bmp",i + 1);
		gen_pts(file, 
			M_PI * (rand()%80-40) / 180.0, M_PI * (rand()%40-20) / 180.0, M_PI * (rand()%40-20) / 180.0,
			rand()%30-15, rand()%30-15, 512.0 + rand()%30,
			alpha, beta, gamma,
			u0, v0, k1, k2, w, h, data[i]);
	};
	// `@Ŋe摜̃zOtBvZBYc݂͊܂܂ȂB
	for(i = 0;i < img_n;i++)
	{
		estimate_homography(data[i].wpts, data[i].cpts, data[i].pts_num, data[i].H);
	};

	// ̉摜p[^𐄒BYcݐ܂ށB
	estimate_intrinsic(data, img_n, alpha, beta, gamma, u0, v0, k1, k2);

	for(i = 0;i < img_n;i++)
	{
		unsigned char *img;
		unsigned char *out;
		sprintf(file,"./img/test%d.bmp",i + 1);
		load_bmp_rgb(file, &img, &w, &h);
		int x, y;
		double ix, iy, rx, ry;
		out = new unsigned char[3 * w * h];

		for(y = 0;y < h;y++)
		{
			for(x = 0;x < w;x++)
			{
				ix = (x - u0) / 512.0;
				iy = (y - v0) / 512.0;
				rx = x + (x - u0) * (k1 * (ix*ix+iy*iy) + k2 * (ix*ix+iy*iy) * (ix*ix+iy*iy));
				ry = y + (y - v0) * (k1 * (ix*ix+iy*iy) + k2 * (ix*ix+iy*iy) * (ix*ix+iy*iy));
				if(rx > 0 && rx < w && ry > 0 && ry < h)
				{
					int dx, dy;
					dx = rx;dy = ry;
					out[3*(x + y * w) + 0] = img[3*(dx + dy * w) + 0];
					out[3*(x + y * w) + 1] = img[3*(dx + dy * w) + 1];
					out[3*(x + y * w) + 2] = img[3*(dx + dy * w) + 2];
				} else {
					out[3*(x + y * w) + 0] = 0;
					out[3*(x + y * w) + 1] = 0;
					out[3*(x + y * w) + 2] = 0;
				};
			};//x
		};//y

		sprintf(file,"./img/out%d.bmp",i + 1);
		write_bmp_rgb(file, out, w, h);
		delete out;
		delete img;
	};

};

int main()
{
	test();
	return 0;
};

